#version 330 core

layout(location = 0) in vec3 vertexPosition_modelspace;
layout(location = 1) in vec2 vertexUV;
layout(location = 2) in vec3 vertexNormal_modelspace;

out vec2 UV;
out vec3 vertexPosition_worldspace;
out vec3 normal_cameraspace;
out vec3 eyeDirection_cameraspace;
out vec3 lightDirection_cameraspace;
out vec4 ShadowCoord;
out vec3 F_lightDirection_cameraspace;


//out vec3 fragmentColor;

uniform mat4 M;
uniform mat4 V;
uniform mat4 P;
uniform mat4 DepthBiasMVP;

//uniform vec3 CamPos;
uniform vec3 LightPosition_worldspace;
uniform vec3 pPos;
uniform vec3 pDir;

void main() {

	//vec3 Fpos = vec3(1, 1, -7);

	// std position vertex
	gl_Position = (P * V * M) * vec4(vertexPosition_modelspace, 1);
	
	// pos in worldspace
	vertexPosition_worldspace = (M * vec4(vertexPosition_modelspace, 1)).xyz;

	// calc view vector
	vec3 vertexPosition_cameraspace = (V * M * vec4(vertexPosition_modelspace, 1)).xyz;
	eyeDirection_cameraspace = vec3(0, 0, 0) - vertexPosition_cameraspace;
	
	vec3 lightPosition_cameraspace = (V * vec4(LightPosition_worldspace, 1)).xyz;	
	lightDirection_cameraspace = lightPosition_cameraspace + eyeDirection_cameraspace;

	vec3 F_lightPosition_cameraspace = (V * vec4(pPos, 1)).xyz;
	F_lightDirection_cameraspace = F_lightPosition_cameraspace + eyeDirection_cameraspace;
	
	normal_cameraspace = (V * M * vec4(vertexNormal_modelspace, 0)).xyz; // Only correct if ModelMatrix does not scale the model ! Use its inverse transpose if not.

	UV = vertexUV;

	ShadowCoord = DepthBiasMVP * vec4(vertexPosition_modelspace, 1);

}