#version 330 core
/*
in vec2 UV;

out vec4 color;

uniform sampler2D renderedTexture;
uniform float time;

void main(){
	//color = vec4(texture( renderedTexture, UV + 0.005*vec2( sin(time+1024.0*UV.x),cos(time+768.0*UV.y)) ).xyz,1) ;
	color = vec4(texture( renderedTexture, UV ).xyz,1) ;
}
*/

in vec2 UV;

out vec4 color;

uniform sampler2D renderedTexture;
uniform vec2 window;
 

 
void main(void)
{
	float radial_blur = 0.1;
	float radial_bright = 1.0;
	vec2 radial_origin = vec2(0.5,0.5);
	vec2 radial_size = 1/window; 
	vec2 TexCoord = UV;


	vec4 SumColor = vec4(0.0, 0.0, 0.0, 0.0);
	TexCoord += radial_size * 0.5 - radial_origin;
 
	for (int i = 0; i < 10; i++) 
	{
		float scale = 1.0 - radial_blur * (float(i) / 9.0);
		SumColor += texture(renderedTexture, TexCoord * scale + radial_origin);
	}
 
	color = SumColor / 10.0 * radial_bright;
}