#version 330 core

// Interpolated values from the vertex shaders
in vec2 UV;
in vec4 ShadowCoord;

// Ouput data
out vec4 color;

uniform sampler2D myTextureSampler;
uniform vec2 windowSize;


void main(){
	vec3 MaterialDiffuseColor = texture( myTextureSampler, UV ).rgb;
	vec3 MaterialAmbientColor = vec3(0.10,0.10,0.10) * MaterialDiffuseColor;
	//
	//	FLASHLIGHT Circle
	//
	vec3 sm_ndc = ShadowCoord.xyz / ShadowCoord.w;

	//////////// calc pixelsize and make flashlight round first
	vec2 p = sm_ndc.xy * windowSize;                  //vec2(800,600);
    //vec2 m = vec2(400.0,300.0) / vec2(800.0,600.0);
	vec2 m = windowSize / 2.0;  // vec2(400.0,300.0);
    vec2 d = p - m;	
	float r = sqrt(dot(d, d)); // distance of pixel from mouse
	float sizeFlashlight = windowSize.y / 3;		// 190.0;
 
	float flashlightPower = 15.0; 

	// Output color = color of the texture at the specified UV
	color = vec4(MaterialAmbientColor, texture( myTextureSampler, UV).w) ;

	
	// test radius
    if (r > sizeFlashlight) 
    {
		
		color = vec4(MaterialAmbientColor,texture( myTextureSampler, UV ).w);
        
    } else {
		

		float shadowMult = sizeFlashlight/r * 1.1;
		
		color = vec4(shadowMult * MaterialAmbientColor,texture( myTextureSampler, UV ).w);
	}
	
}